#ifndef GLVIEW_H
#define GLVIEW_H

#include <QtGui>
#include <QtOpenGL>
#include <scene.h>


class GLView : public QGLWidget
{
    Q_OBJECT
protected :
    void initializeGL ( ) ;
    void paintGL ( ) ;
    void resizeGL(int width , int height ) ;
    void mousePressEvent(QMouseEvent *event ) ;
    void mouseMoveEvent(QMouseEvent *event ) ;
    void wheelEvent(QWheelEvent *event ) ;
public:
    GLView(Scene *scene,bool perspective = true);
    void setHome(QQuaternion *rotation, QVector3D *translation);

    QSize minimumSizeHint() const;
    QSize sizeHint() const;

    void rotate(QVector3D *newPos );
    void move(QPointF *newPos );

public slots:
    void home();

private:
    bool persp;
    QQuaternion *rotation;
    QVector3D *translation;

    QQuaternion *homeRotation;
    QVector3D *homeTranslation;


    QGLShaderProgram *shader;
    Scene *scene;


    void initShader();
    void perspective(GLdouble fovy, GLdouble aspect, GLdouble zNear, GLdouble zFar);
};

#endif // GLVIEW_H
