#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QMenu>
#include <QMenuBar>
#include <QAction>
#include <QActionGroup>
#include <QIcon>
#include <QMessageBox>
#include <QToolBar>
#include <QStatusBar>
#include <QSlider>
#include <QSplitter>

#include <glview.h>


class MainWindow : public QMainWindow
{
    Q_OBJECT

private:
    QMenuBar *menuBar;

    QMenu *fileMenu;
    QAction *exitAction;

    QMenu *interactionMenu;
    QActionGroup *interactionGroup;
    QAction *cameraMode;
    QAction *editMode;

    QMenu *viewMenu;
    QActionGroup *viewGoup;
    QAction *singleView;
    QAction *dualView;
    QAction *quadView;

    QAction *aboutAction;

    QAction *camHome;

    QToolBar *toolBar;
    QStatusBar *statusBar;

    Scene* scene;

    QSplitter *topSplit;
    QSplitter *bottomSplit;
    QSplitter *verticalSplit;

    GLView *activeView;
    GLView *perspectiveView;
    GLView *frontView;
    GLView *leftView;
    GLView *topView;


    void setActiveView();

public:
    MainWindow(QWidget *parent = 0);
    ~MainWindow();

public slots:
    void showAboutBox();
    void showSingle();
    void showDual();
    void showQuad();
};

#endif // MAINWINDOW_H
