#include "scene.h"

Scene::Scene()
{
}

void Scene::draw()
{
    drawCube();
}

void Scene::drawCube()
{
    GLfloat red[] = {1.0,0.0,0.0};
    GLfloat green[] = {0.0,1.0,0.0};
    GLfloat blue[] = {0.0,0.0,1.0};
    GLfloat cyan[] = {0.0,1.0,1.0};
    GLfloat magenta[] = {1.0,0.0,1.0};
    GLfloat yellow[] = {1.0,1.0,0.0};
    float increment = 1.0/(pow(2,4));

    setMaterial(red);
    glBegin(GL_QUADS);
    glNormal3f(0,1,0);
    for (float x = -0.5; x < 0.5 ; x+= increment) {
        for (float y = -0.5; y < 0.5 ; y+= increment ) {
            glVertex3f( x+increment, 0.5f,y);
            glVertex3f(x, 0.5f,y);
            glVertex3f(x, 0.5f, y+increment);
            glVertex3f( x+increment, 0.5f, y+increment);
        }
    }
    glEnd();


    setMaterial(magenta);
    glBegin(GL_QUADS);
    glNormal3f(0,-1,0);
    for (float x = -0.5; x < 0.5 ; x+= increment) {
        for (float y = -0.5; y < 0.5 ; y+= increment ) {
            glVertex3f( x+increment, -0.5f,y+increment);
            glVertex3f(x, -0.5f,y+increment);
            glVertex3f(x, -0.5f, y);
            glVertex3f( x+increment, -0.5f, y);
        }
    }
    glEnd();


    setMaterial(green);
    glBegin(GL_QUADS);
    glNormal3f(0,0,1);
    for (float x = -0.5; x < 0.5 ; x+= increment) {
        for (float y = -0.5; y < 0.5 ; y+= increment ) {
            glVertex3f( x+increment,y+increment, 0.5f);
            glVertex3f(x, y+increment, 0.5f);
            glVertex3f(x,  y, 0.5f);
            glVertex3f( x+increment, y, 0.5f);
        }
    }
    glEnd();


    setMaterial(yellow);
    glBegin(GL_QUADS);
    glNormal3f(0,0,-1);
    for (float x = -0.5; x < 0.5 ; x+= increment) {
        for (float y = -0.5; y < 0.5 ; y+= increment ) {
            glVertex3f( x+increment,y, -0.5f);
            glVertex3f(x, y,-0.5f);
            glVertex3f(x, y+increment,-0.5f);
            glVertex3f( x+increment,y+increment, -0.5f);
        }
    }
    glEnd();


    setMaterial(blue);
    glBegin(GL_QUADS);
    glNormal3f(-1,0,0);
    for (float x = -0.5; x < 0.5 ; x+= increment) {
        for (float y = -0.5; y < 0.5 ; y+= increment ) {
            glVertex3f( -0.5f, x+increment,y+increment);
            glVertex3f( -0.5f,x+increment,y);
            glVertex3f( -0.5f,x, y);
            glVertex3f(  -0.5f,x, y+increment);
        }
    }
    glEnd();


    setMaterial(cyan);
    glBegin(GL_QUADS);
    glNormal3f(1,0,0);
    for (float x = -0.5; x < 0.5 ; x+= increment) {
        for (float y = -0.5; y < 0.5 ; y+= increment ) {
            glVertex3f( 0.5f, x+increment,y);
            glVertex3f( 0.5f,x+increment,y+increment);
            glVertex3f( 0.5f,x, y+increment);
            glVertex3f(  0.5f,x, y);
        }
    }
    glEnd();
}

void Scene::setMaterial(GLfloat *color )
{
    glMaterialfv(GL_FRONT,GL_AMBIENT,color);
    GLfloat white[] = {1.0,1.0,1.0};
    glMaterialfv(GL_FRONT,GL_DIFFUSE,color);
    glMaterialfv(GL_FRONT,GL_SPECULAR,white);

    GLfloat mShininess[] = {128};
    glMaterialfv(GL_FRONT,GL_SHININESS,mShininess);

}
